/* DO NOT EDIT - THIS IS A GENERATED FILE */

{sga_util.i}
{SetContent.i}

 /* <!--WSS */

DEF VAR cAction AS CHARACTER NO-UNDO.
DEF VAR cUserID AS CHARACTER NO-UNDO.
DEF VAR cPassword AS CHARACTER NO-UNDO.
DEF VAR cEmail AS CHARACTER NO-UNDO.
DEF VAR cSecUserID AS CHARACTER NO-UNDO.
DEF VAR cEncounteredError AS CHARACTER NO-UNDO.
DEF VAR cCollabGrpID AS CHARACTER NO-UNDO.
DEF VAR cError AS CHARACTER NO-UNDO.
DEF VAR cPosition AS CHARACTER NO-UNDO.
DEF VAR cParentMessage AS CHARACTER NO-UNDO.
DEF VAR cHackerMessage AS CHARACTER NO-UNDO.

DEF VAR cMsgPerPage AS INTEGER INIT 10 NO-UNDO.
DEF VAR i AS INTEGER NO-UNDO.
DEF VAR iNextMsgNumber AS INTEGER NO-UNDO.
DEF VAR iPrevMsgNumber AS INTEGER NO-UNDO.
DEF VAR iMsgNumber AS INTEGER NO-UNDO.
DEF VAR iCurrentMsgNumber AS INTEGER NO-UNDO.


{AlertBox.i}
{MakeID3.i}
{EnglishDay.i}
{AbbrRegard.i}
{StripHTML.i}

FUNCTION PreviewMsg RETURNS CHARACTER (INPUT cMsg AS CHARACTER):

  DEF VAR iLength AS INTEGER NO-UNDO.

  /* Get rid of carriage returns in the message, they mess up the view */

  ASSIGN cMsg = REPLACE(cMsg, "~n", " ").
  ASSIGN cMsg = REPLACE(cMsg, "~r", " ").

  /* Blow away common HTML markups */

  ASSIGN cMsg = StripHTML(cMsg).

  /* Determine if the message is small enough to return all of it */ 

  ASSIGN iLength = LENGTH(cMsg).
  IF iLength > 30 THEN RETURN SUBSTRING(cMsg, 1, 30) + "...".
  ELSE RETURN cMsg.

END.  /* FUNCTION PreviewMsg */

ASSIGN 
cUserID = GET-VALUE("UserID")
cPassword = GET-VALUE("Password")
cEmail = GET-VALUE("Email")
cAction = GET-VALUE("Action")
cCollabGrpID = GET-VALUE("CollabGrpID")
cSecUserID = GET-VALUE("SecUserID")
cPosition = GET-VALUE("Position")
cParentMessage = GET-VALUE("ParentMessage").


/* If the user has cookies turned off, then the session id will be blank */
/* This messes things up if two or more people have their cookies turned */
/* off.                                                                  */

IF GET-VALUE("SecUserID") = "" THEN DO:

     /* --> */

PUT STREAM StdOut UNFORMATTED '    <html>~n'.
PUT STREAM StdOut UNFORMATTED 'Hmmm, cannot find your session information - do you have cookies and javascript enabled?~n'.
PUT STREAM StdOut UNFORMATTED '    </html>~n'.     /* <!--WSS */
    RETURN.
END.

IF GET-VALUE("MessageNumber") <> "" THEN 
  ASSIGN iMsgNumber = INT(GET-VALUE("MessageNumber")).
ELSE 
  ASSIGN iMsgNumber = 0.

/* See if we can nab stuff from the state table if not coming in from the */
/* browser.                                                               */

IF cCollabGrpID = "" THEN DO:
  {state/ReadSessionVar.i "CollabGrp.CollabGrpID" cCollabGrpID}
END.

ASSIGN cEncounteredError = "".

/* Determine if we have a good collaberation group */

FIND CollabGrp NO-LOCK
WHERE CollabGrp.CollabGrpID = cCollabGrpID
NO-ERROR.

IF NOT AVAILABLE CollabGrp THEN DO: 

  AlertBox("Bad Collaboration Group ID!").
  RETURN.

END.

/* Determine what to do on Action.  If action is not one of these, then */
/* we assume guest and will not put out any hyperlinks to the messages. */

IF cAction = "Create" THEN RUN ipCreate.
ELSE IF cAction = "Login" THEN RUN ipLogin.
ELSE IF cAction = "Post" THEN RUN ipPost.
ELSE IF cAction = "Edit" THEN RUN ipEdit.

/* ------------------------ Internal Procedures ------------------------- */

/* Re-Edits a post */

PROCEDURE ipEdit:

  DEF VAR cSecUserID AS CHARACTER NO-UNDO.

  /* Figure out who is logged in */

  {state/ReadSessionVar.i "SecUser.SecUserID" cSecUserID}

  /* Figure out the message we are updating */

  FIND CollabMsg EXCLUSIVE-LOCK
  WHERE CollabMsg.MsgNumber = INT(GET-VALUE("EditMessage")).

  /* Figure out if they have any business updating that message */

  IF CollabMsg.SecUserID <> cSecUserID THEN DO:
    cHackerMessage = "Ah... that message isn't yours... stop being naughty".
    RETURN.
  END. /* IF CollabMsg.SecUserID <> cSecUserID */

  ASSIGN 
  CollabMsg.MsgText = GET-VALUE("MsgText")
  CollabMsg.MsgSubject = GET-VALUE("MsgSubject").

END. /* PROCEDURE ipEdit */

/* Posts a message as received from the PreviewMessage.html screen */

PROCEDURE ipPost:

  DEF VAR cMsgText AS CHARACTER NO-UNDO.
  DEF VAR cMsgSubject AS CHARACTER NO-UNDO.
  DEF VAR cSecUserID AS CHARACTER NO-UNDO.

  ASSIGN 
  cMsgText = GET-VALUE("MsgText")
  cMsgSubject = GET-VALUE("MsgSubject").

  {state/ReadSessionVar.i "SecUser.SecUserID" cSecUserID}

  RUN CrtMessage.p 
  (INPUT cSecUserID,
   INPUT cMsgSubject,
   INPUT cMsgText,
   INPUT cCollabGrpID,
   INPUT cParentMessage).

END.

/* Creates a login from the RegLogin.html screen. */

PROCEDURE ipCreate:

  IF CAN-FIND(SecUser WHERE SecUser.Login = cUserID) THEN DO:

    AlertBox("That Login is already used by someone!").
     /* --> */

PUT STREAM StdOut UNFORMATTED '    <script language=~"javascript~">~n'.
PUT STREAM StdOut UNFORMATTED '    window.location=~"http://' SERVER_NAME + SCRIPT_NAME '/Chat/RegLogin.html?CollabGrpID=' cCollabGrpID '~";~n'.
PUT STREAM StdOut UNFORMATTED '    </script>~n'.     /* <!--WSS */
    RETURN.

  END.  /* IF CAN-FIND(SecUser WHERE SecUser.Login = cUserID) */

  RUN CrtLogin.p 
  (INPUT cUserID, 
   INPUT cPassword, 
   INPUT cEmail, 
   INPUT cCollabGrpID).

  /* Now that we have some records to work with, log them in automatically */

  RUN ipLogin.

END. /* PROCEDURE ipCreate */

/* Performs a login from the RegLogin.html screen */

PROCEDURE ipLogin:

  FIND SecUser NO-LOCK
  WHERE SecUser.Login = cUserID
    AND SecUser.Password = cPassword
  NO-ERROR.

  /* If the user has cookies turned off, then the session id will be blank */
  /* This messes things up if two or more people have their cookies turned */
  /* off.                                                                  */

  IF GET-VALUE("SecUserID") = "" THEN DO:

    AlertBox("Hmmm, can't find your session data, do you have cookies turned on?").
     /* --> */

PUT STREAM StdOut UNFORMATTED '    <script language=~"javascript~">~n'.
PUT STREAM StdOut UNFORMATTED '    window.location=~"http://' SERVER_NAME + SCRIPT_NAME '/Chat/RegLogin.html?CollabGrpID=' cCollabGrpID '~";~n'.
PUT STREAM StdOut UNFORMATTED '    </script>~n'.     /* <!--WSS */
    RETURN.
END.

  IF AVAILABLE SecUser THEN DO: 
    {state/WriteSessionVar.i "SecUser.SecUserID" SecUser.SecUserID}
    {state/WriteSessionVar.i "CollabGrp.CollabGrpID" CollabGrp.CollabGrpID}
    {state/WriteSessionVar.i "Login Date" STRING(TODAY)}
  END.
  ELSE ASSIGN cEncounteredError = "No SecUser Record found!".

END. /* PROCEDURE ipLogin */

/* Encountered any errors, then bail */

IF cEncounteredError <> "" THEN DO:

  AlertBox("Encountered an error: " + cEncounteredError). 
     /* --> */

PUT STREAM StdOut UNFORMATTED '<script language=~'javascript~'>~n'.
PUT STREAM StdOut UNFORMATTED '    window.location=~"http://' SERVER_NAME + SCRIPT_NAME '/Chat/RegLogin.html?CollabGrpID=' cCollabGrpID '~";~n'.
PUT STREAM StdOut UNFORMATTED '    </script>~n'.     /* <!--WSS */
  RETURN.

END.

/* Render the page below */
 /* --> */

PUT STREAM StdOut UNFORMATTED '<!-- $Header: /home/appl/opensrc/kitty/Chat/RCS/ListMessage.html,v 1.13 2002/05/04 21:40:54 sauge Exp sauge $ -->~n'.
PUT STREAM StdOut UNFORMATTED '<html>~n'. /* <!--WSS */
IF cHackerMessage <> "" THEN DO:
 /* --> */

PUT STREAM StdOut UNFORMATTED '' cHackerMessage '~n'. /* <!--WSS */
RETURN.
END.
 /* --> */

PUT STREAM StdOut UNFORMATTED '<head>~n'.
PUT STREAM StdOut UNFORMATTED '<title>List Messages</title>~n'.
PUT STREAM StdOut UNFORMATTED '<meta http-equiv=~"Content-Type~" content=~"text/html; charset=iso-8859-1~">~n'.
PUT STREAM StdOut UNFORMATTED '</head>~n'.
PUT STREAM StdOut UNFORMATTED '<body bgcolor=~"#000000~" text=~"#9481ED~" link=~"#9481ED~" vlink=~"#9481ED~" alink=~"#9481ED~">~n'.
PUT STREAM StdOut UNFORMATTED '<table width=~"90%~" border=~"0~" cellspacing=~"0~" align=~"center~">~n'.
PUT STREAM StdOut UNFORMATTED '  <tr bgcolor=~"#FF33FF~"> ~n'.
PUT STREAM StdOut UNFORMATTED '    <td>~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.
PUT STREAM StdOut UNFORMATTED '        <font color=~"#000000~">Date</font>~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td> ~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.
PUT STREAM StdOut UNFORMATTED '        <font color=~"#000000~">Msg No.</font> ~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td> ~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.
PUT STREAM StdOut UNFORMATTED '        <font color=~"#000000~">Login</font> ~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td> ~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.
PUT STREAM StdOut UNFORMATTED '        <font color=~"#000000~">Subject</font> ~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '  </tr>~n'. /* <!--WSS */
FIND CollabGrp NO-LOCK
WHERE CollabGrp.CollabGrpID = cCollabGrpID
NO-ERROR.

/* Determine how we are to render the pages */

/* Entering with a prev or next link */

IF iMsgNumber > 0 THEN DO:

  ASSIGN iCurrentMsgNumber = iMsgNumber.
  RUN ipDisplayPage (INPUT iCurrentMsgNumber).
END.

/* Entered with no position, or position at the top */

ELSE 
IF (cPosition = "" or cPosition="Top") THEN DO: 

  FIND CollabMsg NO-LOCK
  WHERE CollabMsg.CollabGrpID = cCollabGrpID
    AND CollabMsg.LinkNextMsgNumber = ?
  NO-ERROR.

  /* Need this IF for an empty list of messages! */
  IF AVAILABLE CollabMsg THEN DO:
    ASSIGN iCurrentMsgNumber = CollabMsg.MsgNumber.
    RUN ipDisplayPage (INPUT iCurrentMsgNumber).
  END.

END.

IF iCurrentMsgNumber <> 0 THEN 
RUN ipComputeNextMsgNumber
(INPUT iCurrentMsgNumber,
 OUTPUT iNextMsgNumber).

IF iCurrentMsgNumber <> 0 THEN 
RUN ipComputePrevMsgNumber
(INPUT iCurrentMsgNumber,
 OUTPUT iPrevMsgNumber).

PROCEDURE ipComputeNextMsgNumber:

  DEF INPUT PARAMETER iStartMsgNumber AS INTEGER NO-UNDO.
  DEF OUTPUT PARAMETER ipNextMsgNumber AS INTEGER NO-UNDO.

  ASSIGN i = 0
         ipNextMsgNumber = iStartMsgNumber.
  REPEAT:

    FIND CollabMsg NO-LOCK
    WHERE CollabMsg.CollabGrpID = cCollabGrpID
      AND CollabMsg.MsgNumber = ipNextMsgNumber
    NO-ERROR.

    IF CollabMsg.LinkPrevMsgNumber = ? THEN DO:

      ASSIGN ipNextMsgNumber = CollabMsg.MsgNumber.
      LEAVE.

    END. /* IF CollabMsg.LinkNextMsgNumber = ? */

    ASSIGN ipNextMsgNumber = CollabMsg.LinkPrevMsgNumber.

    ASSIGN i = i + 1.
    IF i = cMsgPerPage THEN LEAVE.

  END. /* REPEAT */
  
END. /* PROCEDURE ipComputeNextMsgNumber */

PROCEDURE ipComputePrevMsgNumber:

  DEF INPUT PARAMETER iStartMsgNumber AS INTEGER NO-UNDO.
  DEF OUTPUT PARAMETER ipNextMsgNumber AS INTEGER NO-UNDO.

  ASSIGN i = 0
         ipNextMsgNumber = iStartMsgNumber.
  REPEAT:

    FIND CollabMsg NO-LOCK
    WHERE CollabMsg.CollabGrpID = cCollabGrpID
      AND CollabMsg.MsgNumber = ipNextMsgNumber
    NO-ERROR.

    IF CollabMsg.LinkNextMsgNumber = ? THEN DO:

      ASSIGN ipNextMsgNumber = CollabMsg.MsgNumber.
      LEAVE.

    END. /* IF CollabMsg.LinkNextMsgNumber = ? */

    ASSIGN ipNextMsgNumber = CollabMsg.LinkNextMsgNumber.

    ASSIGN i = i + 1.
    IF i = cMsgPerPage THEN LEAVE.

  END. /* REPEAT */
  
END. /* PROCEDURE ipComputePrevMsgNumber */

PROCEDURE ipDisplayPage:

  DEF INPUT PARAMETER ipNextMsgNumber AS INTEGER NO-UNDO.

  /* We are walking a double linked list here */

  REPEAT:

    FIND CollabMsg
    WHERE CollabMsg.MsgNumber = ipNextMsgNumber
      AND CollabMsg.CollabGrpID = cCollabGrpID
    NO-ERROR.

    IF NOT AVAILABLE CollabMsg THEN LEAVE.

    FIND SecUser OF CollabMsg NO-LOCK NO-ERROR.

    RUN ipDispMsgRow.

    ASSIGN ipNextMsgNumber = CollabMsg.LinkPrevMsgNumber.

    ASSIGN i = i + 1.
    IF i = cMsgPerPage THEN LEAVE.

  END.

END. /* PROCEDURE ipDisplayPage */

PROCEDURE ipDispMsgRow:
 /* --> */

PUT STREAM StdOut UNFORMATTED '  <tr> ~n'.
PUT STREAM StdOut UNFORMATTED '    <td><center><font color=~"#9481ED~">' EnglishDay(CollabMsg.CreateDate) ' ' CollabMsg.CreateDate ' </font></center></td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td><center><font color=~"#9481ED~"><a href=~"ViewMessage.html?MessageNumber=' CollabMsg.MsgNumber '~">' CollabMsg.MsgNumber FORMAT ">9999" '</a> </font></center></td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td><center><font color=~"#9481ED~">' SecUser.Login '</font></center></td>~n'.
PUT STREAM StdOut UNFORMATTED '    <td><font color=~"#9481ED~"> ' AbbrRegard(CollabMsg.MsgSubject) '</font></td>~n'.
PUT STREAM StdOut UNFORMATTED '  </tr>~n'.
PUT STREAM StdOut UNFORMATTED '  <tr>~n'.
PUT STREAM StdOut UNFORMATTED '  <td></td>~n'.
PUT STREAM StdOut UNFORMATTED '  <td></td>~n'.
PUT STREAM StdOut UNFORMATTED '  <td></td>~n'.
PUT STREAM StdOut UNFORMATTED '  <td><pre>' PreviewMsg(CollabMsg.MsgText) '</pre></td>~n'.
PUT STREAM StdOut UNFORMATTED '  </tr>~n'. /* <!--WSS */
END.
 /* --> */

PUT STREAM StdOut UNFORMATTED '</table>~n'.
PUT STREAM StdOut UNFORMATTED '<p>&nbsp;</p>~n'.
PUT STREAM StdOut UNFORMATTED '<p>&nbsp;</p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><font color=~"#9481ED~">~n'.
PUT STREAM StdOut UNFORMATTED '<a href=~"ListMessage.html?Position=Top~">Top</a> ~n'.
PUT STREAM StdOut UNFORMATTED '<a href=~"ListMessage.html?MessageNumber=' iPrevMsgNumber '~">Next</a> ~n'.
PUT STREAM StdOut UNFORMATTED '<a href=~"ListMessage.html?MessageNumber=' iNextMsgNumber '~">Prev</a> ~n'.
PUT STREAM StdOut UNFORMATTED '  <!-- <a href=~"ListMessage.html?Position=Bottom~">Bottom</a> --> </font></p> ~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><font color=~"#9481ED~"><a href=~"InputMessage.html~">Post</a></font></p>~n'.
PUT STREAM StdOut UNFORMATTED '</body>~n'.
PUT STREAM StdOut UNFORMATTED '</html>~n'.
