/* MakeSeq.i
 *
 * Function that will create a unique sequence ID for the records created
 * within the system.  Reason for this instead of just an integer is so that
 * this ID can be placed on to the web in an URL and not worry about someone
 * fiddling with the values on a saved web page to access other records in 
 * the database.
 *
 * Written by Scott Auge scott_auge@yahoo.com
 * Copyright (c) 2001 Amduus Information Works
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 */

DEF VAR RCSVersionMakeID AS CHARACTER INIT "$Header: /home/appl/opensrc/kitty/RCS/MakeID.i,v 1.1 2002/04/07 14:58:52 sauge Exp $" NO-UNDO.

FUNCTION MakeID RETURNS CHARACTER (INPUT Seq AS INTEGER):

  DEF VAR i AS CHARACTER NO-UNDO.

  RUN bl/RandomString.p (INPUT 10, OUTPUT i).

  ASSIGN i = i + STRING (Seq).

  RETURN i.

END. /* FUNCTION MakeSeq() */
