/*E4GL-I*/ {&OUT} '<!--WSMETA NAME="wsoptions" CONTENT="include" -->~n'.
 /*Tag=<!--WSS*/ 

/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR SHORTLIST_I_RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/portal/src/RCS/ShortList.i,v 1.4 2002/06/30 05:07:39 sauge Exp sauge $" NO-UNDO.

{date2txt.i}
{Summary.i}

FUNCTION ShortList RETURNS CHAR 
(INPUT cCategoryName AS CHARACTER,
 INPUT iNumberListed AS INTEGER):

  DEF VAR iNumberCharacters AS INTEGER NO-UNDO.
  DEF VAR iListCount        AS INTEGER NO-UNDO.
  DEF VAR dLastDate         AS DATE NO-UNDO.
  DEF VAR c                 AS CHARACTER NO-UNDO.
  DEF VAR e                 AS CHARACTER NO-UNDO.

/* If iNumberListed is not set, go with the default. */

IF iNumberListed = 0 OR iNumberListed = ? THEN DO:

  RUN ReadParm.p (INPUT "CMS",
                  INPUT "Article",
                  INPUT "NumberListed",
                  OUTPUT c,
                  OUTPUT e).

  ASSIGN iNumberListed = INT (c).

END. /* IF iNumberListed = 0 OR iNumberListed = ? */

  RUN ReadParm.p (INPUT "CMS",
                  INPUT "Article",
                  INPUT "SummaryChars",
                  OUTPUT c,
                  OUTPUT e).

  ASSIGN iNumberCharacters = INT (c).

  ASSIGN iListCount = 0.

  FIND Category NO-LOCK
  WHERE Category.Name = cCategoryName
  NO-ERROR.

  IF NOT AVAILABLE Category THEN
    RETURN "".
 /*Tag=-->*/ 

{&OUT} '  <table width="80%" border="0" cellspacing="0">~n'.

{&OUT} '  <tr>~n'.

{&OUT} '  <td><span class="shrtlisthdr">~n'.
{&OUT} /*Tag=`*/ Category.Name /*Tag=`*/ .
{&OUT} '  </span></td>~n'.

{&OUT} '  </tr>~n'.

 /*Tag=<!--WSS*/ 
  FOR EACH Article NO-LOCK
  WHERE Article.CategoryID = Category.CategoryID
  BY Article.StartDate DESCENDING:

    IF iListCount > iNumberListed THEN LEAVE.

    ASSIGN iListCount = iListCount + 1.

    IF Article.StartDate <> dLastDate THEN DO:

      ASSIGN dLastDate = Article.StartDate.
 /*Tag=-->*/ 

{&OUT} '      <tr>~n'.

{&OUT} '      <td><span class="shrtlistlink">~n'.
{&OUT} /*Tag=`*/ Date2Txt(INPUT Article.StartDate) /*Tag=`*/ .
{&OUT} '      </span></td>~n'.

{&OUT} '      </tr>~n'.

 /*Tag=<!--WSS*/  
    END.
 /*Tag=-->*/ 

{&OUT} '    <tr><td>~n'.
{&OUT} '    <span class="shrtlistlink">~n'.
{&OUT} '    <a href="ViewArticle.html?ArticleID=' /*Tag=`*/ Article.ArticleID /*Tag=`*/ '"> ' /*Tag=`*/ Article.ArticleTitle /*Tag=`*/ ' </a>~n'.
{&OUT} '    </span></td>~n'.
{&OUT} '    </tr>~n'.
{&OUT} '    <tr>~n'.

{&OUT} '    <td> <span class="shrtlistlink">' /*Tag=`*/ Summary(Article.ArticleText, iNumberCharacters) /*Tag=`*/ '.... </span></td>~n'.

{&OUT} '    </tr>~n'.
{&OUT} '    <tr>~n'.
{&OUT} '    <td>&nbsp~; </td>~n'.
{&OUT} '    </tr>~n'.

 /*Tag=<!--WSS*/ 
  END. /* FOR EACH Article */
 /*Tag=-->*/ 

{&OUT} '  </table>~n'.

 /*Tag=<!--WSS*/ 
  RETURN "".

END. /* FUNCTION ShortList */
 /*Tag=-->*/ 
/************************* END OF HTML *************************/
/*
** File: /home/appl/opensrc/portal/src/ShortList.i
** Generated on: 2002-06-29 20:31:58
** By: WebSpeed Embedded SpeedScript Preprocessor
** Version: 2
** Source file: /home/appl/opensrc/portal/src/ShortList.htm
** Options: include,wsoptions-found
**
** WARNING: DO NOT EDIT THIS FILE.  Make changes to the original
** HTML file and regenerate this file from it.
**
*/

/* end */
